local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.IncomingDamage2 = a.incomingDamage2()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.Chi = s.Power("player", SPELL_POWER_CHI )
	x.MaxChi = s.MaxPower("player", SPELL_POWER_CHI)
	x.Energy = s.Power("player", SPELL_POWER_ENERGY )
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown() + x.Lag
	x.Spec = s.TalentMastery()
	x.ActiveEnemies = a.ActiveEnemies()
	x.MaxHealth = s.MaxHealth("player")
	a.Flash("Legacy of the Emperor")
	a.Flash("Spear Hand Strike", "Paralysis", "Leg Sweep as Interrupt") -- interrupt casters
	a.Flash("fortifying_brew,if=incoming_damage_2>health.max*0.5") -- emergency CD for every spec
	a.FlashAll("Nimble Brew", "Tiger's Lust", "Charging Ox Wave", "Dampen Harm", "Diffuse Magic", "Detox") -- Talents
	if x.Spec == 1 then
		-- Brewmaster
		x.ShuffleRemains = s.BuffDuration(115307--[[Shuffle]], "player")
		x.EnergyPerSecond = a.energyRegeneration()
		x.TimeToMax = ((100 - x.Energy) / x.EnergyPerSecond) - s.GlobalCooldown()
		x.StaggerAmount = a.getStagger()
		x.KegSmashCDRemains = s.SpellCooldown(121253--[[Keg Smash]])
		a.Flash("stance,choose=sturdy_ox")
		a.FlashAll("Clash", "Roll") -- if we are not in range, use these
		a.Flash("Provoke") -- taunt if tanking and not keeping aggro
		a.Flash("Dizzying Haze") -- something to do at range, while kiting or to set up a Breath of Fire
		a.Flash("black_ox_statue")
		if x.ActiveEnemies < 3 then
			a.Flash("auto_attack",
					"invoke_xuen,if=talent.invoke_xuen.enabled",
					"elusive_brew",
					-- Purify off stagger, being more liberal the longer time remains on shuffle.
					"purifying_brew,if=stagger.amount&stagger.amount%health.max*100>20-buff.shuffle.remains",
					"guard,if=buff.shuffle.remains>6&incoming_damage_2>health.max*0.5",
					"blackout_kick,if=buff.shuffle.remains<=1.5",
					"blackout_kick,if=chi=chi.max&energy.time_to_max<=2",
					"blackout_kick,if=chi>=chi.max-1&cooldown.keg_smash.remains<=1",
					"keg_smash",
					"expel_harm,if=incoming_damage_2>health.max*0.3",
					"jab,if=energy.time_to_max<=1",
					"tiger_palm,if=buff.tiger_power.down",
					"chi_burst,if=talent.chi_burst.enabled",
					"chi_wave,if=talent.chi_wave.enabled",
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking",
					"blackout_kick,if=chi=chi.max",
					"jab,if=energy+energy.regen*cooldown.keg_smash.remains>=80",
					"tiger_palm")
		else
			a.Flash("auto_attack",
					"invoke_xuen,if=talent.invoke_xuen.enabled",
					"elusive_brew",
					-- Purify off stagger, being more liberal the longer time remains on shuffle.
					"purifying_brew,if=stagger.amount&stagger.amount%health.max*100>20-buff.shuffle.remains",
					"guard,if=buff.shuffle.remains>6&incoming_damage_2>health.max*0.5",
					"blackout_kick,if=buff.shuffle.remains<=1.5",
					"blackout_kick,if=chi=chi.max&energy.time_to_max<=2",
					"blackout_kick,if=chi>=chi.max-1&cooldown.keg_smash.remains<=1",
					"keg_smash",
					"expel_harm,if=incoming_damage_2>health.max*0.3",
					"leg_sweep",
					"rushing_jade_wind,if=talent.rushing_jade_wind.enabled",
					"spinning_crane_kick,if=!talent.rushing_jade_wind.enabled&energy.time_to_max<=1",
					"tiger_palm,if=buff.tiger_power.down",
					"chi_burst,if=talent.chi_burst.enabled",
					"chi_wave,if=talent.chi_wave.enabled",
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking",
					"breath_of_fire",
					"blackout_kick,if=chi=chi.max",
					"jab,if=talent.rushing_jade_wind.enabled&energy.time_to_max<cooldown.rushing_jade_wind.remains&energy.time_to_max<cooldown.keg_smash.remains",
					"spinning_crane_kick,if=!talent.rushing_jade_wind.enabled&energy+energy.regen*cooldown.keg_smash.remains>=80",
					"tiger_palm")
		end
	elseif x.Spec == 2 then
		-- Mistweaver
		x.Bloodlust = a.Bloodlust()
		x.BuffLucidityRemains = s.BuffDuration(137288--[[Lucidity]], "player")
		x.BuffMuscleMemoryRemains = s.BuffDuration(139597--[[Muscle Memory]], "player")
		a.Flash("stance,choose=wise_serpent")
		a.Flash("jade_serpent_statue")
		a.Flash("uplift")
		a.Flash("chi_brew,if=talent.chi_brew.enabled&chi<=2&((charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)")
		a.Flash("auto_attack",
				"crackling_jade_lightning,if=buff.bloodlust.up&buff.lucidity.up",
				"tiger_palm,if=buff.muscle_memory.up&buff.lucidity.up",
				"jab,if=buff.lucidity.up",
				"renewing_mist",
				"tiger_palm,if=buff.muscle_memory.up&!buff.tiger_power.up",
				"blackout_kick,if=buff.muscle_memory.up&chi>1&!buff.serpents_zeal.up",
				"tiger_palm,if=buff.muscle_memory.up",
				"chi_wave,if=talent.chi_wave.enabled",
				"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking")
				
	elseif x.Spec == 3 then
		-- Windwalker
		x.EnergyPerSecond = a.energyRegeneration()
		x.TimeToMax = ((100 - x.Energy) / x.EnergyPerSecond) - s.GlobalCooldown()
		x.Bloodlust = a.Bloodlust()
		x.TrinketProcAgilityRemains = s.BuffDuration({148903--[[Vicious]],
											   146308--[[Dextrous]],
											   148896--[[Ferocity]],
											   146310--[[Restless Agility]],
											   126554--[[Agile]],
											   138699--[[Superluminal]],
											   138938--[[Juju Madness]],
											   138699--[[Superluminal]],
											   }, "player")
		x.DebuffRisingSunKickRemains = s.MyDebuffDuration(130320--[[Rising Sun Kick]], "target")
		a.Flash("stance,choose=fierce_tiger")
		a.Flash("Legacy of the White Tiger")
		a.Flash("Flying Serpent Kick", "Roll")
		if x.ActiveEnemies >= 5 and not s.HasTalent(116847--[[Rushing Jade Wind]]) then
			a.Flash("auto_attack",
			        "virmens_bite_potion,if=buff.bloodlust.react|target.time_to_die<=60",
			        "synapse_springs",
					"berserking",
					"blood_fury",
					"chi_brew,if=talent.chi_brew.enabled&chi<=2&(trinket.proc.agility.react|(charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)",
					"tiger_palm,if=buff.tiger_power.remains<=3",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack=20",
					"tigereye_brew,if=buff.tigereye_brew_use.down&trinket.proc.agility.react",
					"tigereye_brew,if=buff.tigereye_brew_use.down&chi>=2&(trinket.proc.agility.react|buff.tigereye_brew.stack>=15|target.time_to_die<40)&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"energizing_brew,if=energy.time_to_max>5",
					"rising_sun_kick,if=debuff.rising_sun_kick.down",
					"tiger_palm,if=buff.tiger_power.down&debuff.rising_sun_kick.remains>1&energy.time_to_max>1",
					"invoke_xuen,if=talent.invoke_xuen.enabled",
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking",
					"chi_wave,if=talent.chi_wave.enabled",
					"chi_burst,if=talent.chi_burst.enabled",
					"rising_sun_kick,if=chi=chi.max",
					"spinning_crane_kick")
		elseif not s.Channeling(113656--[[Fists of Fury]], "player") then
			a.Flash("auto_attack",
			        "virmens_bite_potion,if=buff.bloodlust.react|target.time_to_die<=60",
			        "synapse_springs",
					"berserking",
					"blood_fury",
					"chi_brew,if=talent.chi_brew.enabled&chi<=2&(trinket.proc.agility.react|(charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)",
					"tiger_palm,if=buff.tiger_power.remains<=3",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack=20",
					"tigereye_brew,if=buff.tigereye_brew_use.down&trinket.proc.agility.react",
					"tigereye_brew,if=buff.tigereye_brew_use.down&chi>=2&(trinket.proc.agility.react|buff.tigereye_brew.stack>=15|target.time_to_die<40)&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"energizing_brew,if=energy.time_to_max>5",
					"rising_sun_kick,if=debuff.rising_sun_kick.down",
					"tiger_palm,if=buff.tiger_power.down&debuff.rising_sun_kick.remains>1&energy.time_to_max>1",
					"invoke_xuen,if=talent.invoke_xuen.enabled",
					"rising_sun_kick",
					"fists_of_fury,if=buff.energizing_brew.down&energy.time_to_max>4&buff.tiger_power.remains>4",
					"chi_wave,if=talent.chi_wave.enabled&energy.time_to_max>2",
					"chi_burst,if=talent.chi_burst.enabled&energy.time_to_max>2", 
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&energy.time_to_max>2&!dot.zen_sphere.ticking",
					"blackout_kick,if=buff.combo_breaker_bok.react",
					"tiger_palm,if=buff.combo_breaker_tp.react&(buff.combo_breaker_tp.remains<=2|energy.time_to_max>=2)",
					"Expel Harm (Windwalker)",
					"Rushing Jade Wind (WW)",
					"jab,if=chi.max-chi>=2",
					"blackout_kick,if=energy+energy.regen*cooldown.rising_sun_kick.remains>=40")
		end
	end
end)
